diff -uNrd ircd-ratbox-1.3-1/include/modules.h BgChat-Ircd/include/modules.h
--- ircd-ratbox-1.3-1/include/modules.h	Tue Jul  8 10:19:07 2003
+++ BgChat-Ircd/include/modules.h	Mon Mar 29 07:17:54 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  modules.h: A header for the modules functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: modules.h,v 7.54.2.3 2003/07/08 14:19:07 leeh Exp $
+ *  $Id: modules.h,v 7.54.2.3 2004/01/02 14:19:07 MaskBg Exp $
  */
 
 #ifndef INCLUDED_modules_h
@@ -137,6 +136,10 @@
 extern struct Message squit_msgtab;
 extern struct Message stats_msgtab;
 extern struct Message svinfo_msgtab;
+extern struct Message svshint_msgtab;
+extern struct Message svsjoin_msgtab;
+extern struct Message svsnick_msgtab;
+extern struct Message services_msgtab;
 extern struct Message testline_msgtab;
 extern struct Message time_msgtab;
 extern struct Message topic_msgtab;
diff -uNrd ircd-ratbox-1.3-1/include/numeric.h BgChat-Ircd/include/numeric.h
--- ircd-ratbox-1.3-1/include/numeric.h	Sun Oct 12 08:50:43 2003
+++ BgChat-Ircd/include/numeric.h	Fri Apr  9 05:22:58 2004
@@ -117,9 +117,16 @@
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
 
+
+#define RPL_IDENTUSERS       267        /* for showing id users for ns */
+#define RPL_OSIDUSERS        268	/* for showin' services admin */
+#define RPL_GLIDUSERS        269	/* Gliner admin */
+
+
 #define RPL_ACCEPTLIST	     281
 #define RPL_ENDOFACCEPT      282
 
+#define RPL_INGMODE          294
 /* numeric_replies */
 
 #define RPL_NONE             300
@@ -151,8 +158,13 @@
 #define RPL_LISTEND          323
 #define RPL_CHANNELMODEIS    324
 
-#define RPL_CREATIONTIME     329
 
+#define RPL_WHOISSVSHINT     325           /* identified with services - tenks for maskbg */
+#define RPL_OS_ID            326        /* identified as a services admin - tenks for maskbg */
+#define RPL_NK_ID            327        /* identified as a Gliner admin - haker4o  */
+#define RPL_SILENCE          328
+
+#define RPL_CREATIONTIME     329
 #define RPL_NOTOPIC          331
 #define RPL_TOPIC            332
 #define RPL_TOPICWHOTIME     333
@@ -220,6 +232,10 @@
 #define ERR_NOTOPLEVEL       413
 #define ERR_WILDTOPLEVEL     414
 
+
+#define ERR_SERV_NICK        415        /* error deoping service nick  */
+
+
 #define ERR_TOOMANYMATCHES   416
 
 #define ERR_UNKNOWNCOMMAND   421
@@ -243,6 +259,9 @@
 
 #define ERR_NOTREGISTERED    451
 
+
+#define ERR_NOREPEATING	     452
+
 #define ERR_ACCEPTFULL       456
 #define ERR_ACCEPTEXIST      457
 #define ERR_ACCEPTNOT        458
@@ -255,6 +274,11 @@
 #define ERR_YOUWILLBEBANNED  466
 #define ERR_KEYSET           467
 
+
+#define ERR_ADMINCHAN        469  // +A chan mode err
+#define ERR_OPERCHAN         470  // +O chan mode err
+
+
 #define ERR_CHANNELISFULL    471
 #define ERR_UNKNOWNMODE      472
 #define ERR_INVITEONLYCHAN   473
@@ -271,7 +295,18 @@
 #define ERR_RESTRICTED       484
 #define ERR_BANNEDNICK       485
 
+
+#define ERR_NOCOLOR          489
+#define ERR_JOINF            490
+
+
 #define ERR_NOOPERHOST       491
+
+
+#define ERR_NOCTCP           492
+#define ERR_NOTALK           493
+#define ERR_NOSPAM           494
+
 
 #define ERR_UMODEUNKNOWNFLAG 501
 #define ERR_USERSDONTMATCH   502
diff -uNrd ircd-ratbox-1.3-1/include/patchlevel.h BgChat-Ircd/include/patchlevel.h
--- ircd-ratbox-1.3-1/include/patchlevel.h	Fri Jan  9 15:05:13 2004
+++ BgChat-Ircd/include/patchlevel.h	Fri Apr  9 05:23:25 2004
@@ -1,29 +1,11 @@
 /*
- *  ircd-ratbox: A slightly useful ircd. 
+ *  ircd-hybrid: A slightly useful ircd. 
  *  patchlevel.h: A header defining the patchlevel.
  *
- *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
- *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
- *  USA
  *
- *  $Id: patchlevel.h,v 7.50.2.15 2004/01/09 20:05:13 androsyn Exp $
+ *  $Id: patchlevel.h,v 7.50.2.15 2004/02/09 20:05:13 haker4o Exp $
  */
-
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "ircd-ratbox-1.3-1"
+#define PATCHLEVEL   "BgChat-Ircd-1.5"
 #endif
+
diff -uNrd ircd-ratbox-1.3-1/include/s_conf.h BgChat-Ircd/include/s_conf.h
--- ircd-ratbox-1.3-1/include/s_conf.h	Fri Dec 19 12:32:49 2003
+++ BgChat-Ircd/include/s_conf.h	Mon Mar 29 07:17:54 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_conf.h: A header for the configuration functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_conf.h,v 7.241.2.12 2003/12/19 17:32:49 androsyn Exp $
+ *  $Id: s_conf.h,v 7.241.2.12 2004/02/09 17:32:49 MaskBg Exp $
  */
 
 #ifndef INCLUDED_s_conf_h
@@ -443,6 +442,11 @@
 extern char *get_oper_name(struct Client *client_p);
 
 extern int yylex(void);
+
+
+extern void add_adv_text(void *);
+extern int IsAdvQuit(char *);
+
 
 extern unsigned long cidr_to_bitmask[];
 
diff -uNrd ircd-ratbox-1.3-1/include/s_misc.h BgChat-Ircd/include/s_misc.h
--- ircd-ratbox-1.3-1/include/s_misc.h	Sat Jun 28 05:22:56 2003
+++ BgChat-Ircd/include/s_misc.h	Mon Mar 29 07:17:54 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_misc.h: A header for the miscellaneous functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_misc.h,v 7.9.2.1 2003/06/28 09:22:56 leeh Exp $
+ *  $Id: s_misc.h,v 7.9.2.1 2004/02/10 09:22:56 MaskBg Exp $
  */
 
 #ifndef INCLUDED_s_misc_h
@@ -41,6 +40,12 @@
                   ((x > _1MEG) ? "Megabytes" : "Kilobytes")))
 #define _GMKv(x)  ( (x > _1TER) ? (float)(x/_1TER) : ((x > _1GIG) ? \
                (float)(x/_1GIG) : ((x > _1MEG) ? (float)(x/_1MEG) : (float)x)))
+
+
+/* for services' nicks  */
+extern long     s_check( char * szName );
+
+extern char *strip_color(const char *, int);
 
 
 #endif
diff -uNrd ircd-ratbox-1.3-1/include/s_serv.h BgChat-Ircd/include/s_serv.h
--- ircd-ratbox-1.3-1/include/s_serv.h	Thu Nov  6 19:00:37 2003
+++ BgChat-Ircd/include/s_serv.h	Mon Mar 29 07:17:54 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_serv.h: A header for the server functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_serv.h,v 7.80.2.3 2003/11/07 00:00:37 leeh Exp $
+ *  $Id: s_serv.h,v 7.80.2.3 2004/02/07 00:00:37 HaKer4o Exp $
  */
 
 #ifndef INCLUDED_serv_h
@@ -251,6 +250,15 @@
 
 extern int MaxClientCount;	/* GLOBAL - highest number of clients */
 extern int MaxConnectionCount;	/* GLOBAL - highest number of connections */
+
+
+extern int CurrentIdentUsers;  /* Currently identified users to services */
+extern int MaxIdentUsers;  /* Max identified users to services */
+extern int CurrentOSidUsers; /* identified S admins  */
+extern int MaxOSidUsers;     /* maximum value */
+extern int CurrentGlinerUsers;     /* Gliner identified users */
+extern int MaxGlinerUsers;     /* Gliner users maximum value */
+
 
 extern int refresh_user_links;
 
diff -uNrd ircd-ratbox-1.3-1/include/serno.h BgChat-Ircd/include/serno.h
--- ircd-ratbox-1.3-1/include/serno.h	Fri Jan  9 15:05:14 2004
+++ BgChat-Ircd/include/serno.h	Mon Mar 29 07:17:54 2004
@@ -1 +1,2 @@
-#define SERIALNUM "20040109_1"
+#define SERIALNUM "20040121_1"
+
diff -uNrd ircd-ratbox-1.3-1/include/supported.h BgChat-Ircd/include/supported.h
--- ircd-ratbox-1.3-1/include/supported.h	Mon Aug  4 15:35:23 2003
+++ BgChat-Ircd/include/supported.h	Mon Mar 29 07:17:54 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  supported.h: Header for 005 numeric etc...
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: supported.h,v 1.31.2.2 2003/08/04 19:35:23 leeh Exp $
+ *  $Id: supported.h,v 1.31.2.2 2004/02/01 19:35:23 MaskBg Exp $
  */
 
 #ifndef INCLUDED_supported_h
@@ -55,13 +54,15 @@
         ConfigChannel.max_bans, \
         ConfigFileEntry.max_targets,NICKLEN-1,TOPICLEN,TOPICLEN
 
+
 #define FEATURES2 "CHANTYPES=%s" \
                   " PREFIX=(ov)@+" \
-		  " CHANMODES=%s%sb,k,l,imnpst" \
+		  " CHANMODES=%s%sb,k,l,imnpstzqCHMAO" \
 		  " NETWORK=%s" \
 		  " CASEMAPPING=%s" \
 		  " CHARSET=ascii" \
 		  " CALLERID" \
+		  " SILENCE" \
 		  " ETRACE" \
 		  " WALLCHOPS"
 
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_kick.c BgChat-Ircd/modules/core/m_kick.c
--- ircd-ratbox-1.3-1/modules/core/m_kick.c	Sun Nov  2 20:35:00 2003
+++ BgChat-Ircd/modules/core/m_kick.c	Mon Mar 29 07:17:53 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_kick.c: Kicks a user from a channel.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_kick.c,v 1.68.2.2 2003/11/03 01:35:00 leeh Exp $
+ *  $Id: m_kick.c,v 1.68.2.2 2004/02/03 01:35:00 MaskBg Exp $
  */
 
 #include "stdinc.h"
@@ -170,6 +169,26 @@
 	{
 		return;
 	}
+
+
+        if (s_check(user)) {
+             sendto_one(source_p, form_str(ERR_SERV_NICK),
+                 me.name, parv[0], user);
+             return;
+        }
+	
+	if (IsOSId(who) && !IsOSId(source_p)) {
+             sendto_one(source_p, ":%s NOTICE %s : You can't kick Services Administrators [%s/%s]",
+                 me.name, source_p->name,parv[2],parv[1]);
+             return;
+	}
+
+	if (dlinkFind(&who->user->nokick, chptr) != NULL) {
+             sendto_one(source_p, ":%s NOTICE %s : You can't kick Nick add to nokick list [%s/%s]",
+                 me.name, source_p->name,parv[2],parv[1]);
+             return;
+	}
+
 
 	msptr = find_channel_membership(chptr, who);
 	if(msptr != NULL)
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_kill.c BgChat-Ircd/modules/core/m_kill.c
--- ircd-ratbox-1.3-1/modules/core/m_kill.c	Thu Nov  6 19:00:42 2003
+++ BgChat-Ircd/modules/core/m_kill.c	Fri Apr  9 05:13:10 2004
@@ -1,27 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrd: an advanced Internet Relay Chat Daemon(ircd).
  *  m_kill.c: Kills a user.
- *
- *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
- *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
- *  USA
- *
- *  $Id: m_kill.c,v 1.82.2.7 2003/11/07 00:00:42 leeh Exp $
+ *  Tenks for MaskBg Fix
+ *  BgChat devel [HaKer4o]
+ *  $Id: m_kill.c,v 1.82.2.7 2004/2/01 00:00:42 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_message.c BgChat-Ircd/modules/core/m_message.c
--- ircd-ratbox-1.3-1/modules/core/m_message.c	Wed Jan  7 20:20:17 2004
+++ BgChat-Ircd/modules/core/m_message.c	Mon Mar 29 07:17:53 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_message.c: Sends a (PRIVMSG|NOTICE) message to a user or channel.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_message.c,v 1.131.2.5 2004/01/08 01:20:17 leeh Exp $
+ *  $Id: m_message.c,v 1.131.2.5 2004/02/07 01:20:17 MaskBg Exp $
  */
 
 #include "stdinc.h"
@@ -431,6 +430,44 @@
 {
 	int result;
 
+	struct Channel *vchan = NULL;
+	char *chname = NULL;
+	struct ResvEntry *ptr;
+
+	chname = chptr->chname;
+
+	vchan = chptr;
+ 
+	if (find_color_ctcp(text, 1) && (vchan->mode.mode & MODE_NOCOLOR) &&
+        !(ptr = (struct ResvEntry *) get_nick_resv(source_p->name)))
+	  {
+	    sendto_one(source_p, form_str(ERR_NOCOLOR), me.name,
+        	   source_p->name, vchan->chname);
+	    return;
+        } else 
+	    if (find_color_ctcp(text, 0) && ircncmp(text, "\001ACTION", 7) && (vchan->mode.mode & MODE_NOCTCP) &&
+ 	    !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name))) &&
+	    !is_chanop(find_channel_membership(vchan, source_p)) && !is_voiced(find_channel_membership(vchan, source_p))) {
+		sendto_one(source_p, form_str(ERR_NOCTCP), me.name,
+            		    source_p->name, vchan->chname);
+		return;
+	    } else 
+		if ((vchan->mode.mode & MODE_NOTALK) /* && ServicesOn */ &&
+		 (!IsNSId(source_p) /* || source_p->ns_reg + ConfigFileEntry.how_old >= time(NULL)*/)  &&
+		 !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name))) &&
+		 !IsOper(source_p)) {
+			sendto_one(source_p, form_str(ERR_NOTALK), me.name,
+	        		    source_p->name, vchan->chname);
+			return;
+		    } else 
+			if (!is_chanop(find_channel_membership(vchan, source_p)) && NoRepeatChannel(vchan) && !IsOper(source_p)) {
+			    if (check_repeat(source_p, vchan, text)) {
+				  sendto_one(source_p, form_str(ERR_NOREPEATING),
+		    				 me.name, source_p->name, vchan->chname);
+    				  return;
+			    }
+			}
+
 	if(MyClient(source_p))
 	{
 		/* idle time shouldnt be reset by notices --fl */
@@ -444,6 +481,10 @@
 		if(result == CAN_SEND_OPV ||
 		   !flood_attack_channel(p_or_n, source_p, chptr, chptr->chname))
 		{
+
+		    if (NoColorChannel(chptr))
+        		text = strip_color(text, 0);
+
 			sendto_channel_butone(client_p, source_p, chptr, command, ":%s", text);
 		}
 	}
@@ -474,12 +515,51 @@
 		  struct Client *source_p, struct Channel *chptr, int flags, const char *text)
 {
 	char c;
+	
+
+	struct Channel *vchan = NULL;
+	char *chname = NULL;
+	int type;
+	struct ResvEntry *ptr;
+
 
 	if(flags & CHFL_VOICE)
 		c = '+';
 	else
 		c = '@';
 
+
+  chname = chptr->chname;
+  vchan = chptr;
+
+  if (find_color_ctcp(text, 1) && (vchan->mode.mode & MODE_NOCOLOR) &&
+      !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name)) /* && !irccmp(ptr->reason, ConfigFileEntry.services_qline)*/))
+  {
+	sendto_one(source_p, form_str(ERR_NOCOLOR), me.name,
+               source_p->name, vchan->chname);
+	return;
+  } else if (find_color_ctcp(text, 0) && ircncmp(text, "\001ACTION", 7) && (vchan->mode.mode & MODE_NOCTCP) &&
+			 !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name)) /*&& !irccmp(ptr->reason, ConfigFileEntry.services_qline)*/) &&
+		     !is_chanop(find_channel_membership(vchan, source_p)) && !is_voiced(find_channel_membership(vchan, source_p))) {
+	sendto_one(source_p, form_str(ERR_NOCTCP), me.name,
+               source_p->name, vchan->chname);
+	return;
+  } else if ((vchan->mode.mode & MODE_NOTALK) &&
+		     !IsNSId(source_p) &&
+		     !(ptr = (struct ResvEntry *) get_nick_resv(source_p->name)) &&
+		     !IsOper(source_p)) {
+    sendto_one(source_p, form_str(ERR_NOTALK), me.name,
+	           source_p->name, vchan->chname);
+	return;
+    } else if (!is_chanop(find_channel_membership(vchan, source_p)) && NoRepeatChannel(vchan) && !IsOper(source_p)) {
+    if (check_repeat(source_p, vchan, text)) {
+	  sendto_one(source_p, form_str(ERR_NOREPEATING),
+		         me.name, source_p->name, vchan->chname);
+      return;
+    }
+  }
+
+
 	if(MyClient(source_p))
 	{
 		/* idletime shouldnt be reset by notice --fl */
@@ -524,12 +604,30 @@
 static void
 msg_client(int p_or_n, const char *command, struct Client *source_p, struct Client *target_p, const char *text)
 {
+
+
+  struct ResvEntry *ptr;
+
+
 	if(MyClient(source_p))
 	{
 		/* reset idle time for message if its not a notice */
 		if((p_or_n != NOTICE) && source_p->user)
 			source_p->user->last = CurrentTime;
 	}
+	
+
+	if (source_p->user && HasSilence(target_p) &&
+	    (target_p != source_p) && !IsOper(target_p) && !IsNSId(source_p))
+	{
+	  sendto_one(source_p, ":%s NOTICE %s :Error: %s is in silence mode and does NOT accept messages from unregistered/unidentified (too recently registered) nicknames",
+				 me.name, source_p->name, target_p->name);
+	  sendto_one(source_p, ":%s NOTICE %s :Error: If you want to send messages to %s you will have to identify or register your nickname",
+				 me.name, source_p->name, target_p->name);
+	  return;
+	} else if (source_p->user && (IsSetTransWin(target_p) || IsSetTransISO(target_p))) {
+	}
+
 
 	if(MyConnect(source_p) && (p_or_n != NOTICE) && target_p->user && target_p->user->away)
 		sendto_one(source_p, form_str(RPL_AWAY), me.name,
@@ -880,4 +978,60 @@
 		}
 	}
 	return (res);
+}
+
+
+/*
+ * finds color or ctcp depending on ctcpcolor
+ * 1 - color
+ * 0 - ctcp
+ *
+ * main procedure from  
+ */
+int find_color_ctcp(const char *msg, int ctcpcolor)
+{
+  const char *c = msg;
+
+  while (*c)
+  {
+	if ((ctcpcolor && (*c == '\003' || *c == '\033')) ||
+		(!ctcpcolor && (*c == '\001')))
+	  break;
+	else
+	  c++;
+  }
+
+  if (*c)
+	return 1;
+
+  return 0;
+}
+
+static int check_repeat(struct Client *source_p,struct Channel *chptr,const char *text)
+{
+  dlink_node *ptr;
+  struct Repeat *repeatptr;
+
+  for (ptr = source_p->user->repeat.head; ptr; ptr = ptr->next) {
+    repeatptr = ptr->data;
+	if (repeatptr->chptr == chptr)
+  	  if (!strcmp(repeatptr->text, text)) {
+    	return 1;
+  	  } else {
+    	MyFree(repeatptr->text);
+    	DupString(repeatptr->text, text);
+  	    repeatptr->lastphrase = CurrentTime;
+	    return 0;
+	  }
+    }
+
+  repeatptr = (struct Repeat *)MyMalloc(sizeof(struct Repeat));
+  repeatptr->chptr = chptr;
+  DupString(repeatptr->text, text);
+  repeatptr->lastphrase = CurrentTime;
+
+  ptr = make_dlink_node();
+  dlinkAdd(repeatptr, ptr, &source_p->user->repeat);
+
+  return 0;
 }
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_nick.c BgChat-Ircd/modules/core/m_nick.c
--- ircd-ratbox-1.3-1/modules/core/m_nick.c	Thu Nov  6 19:00:42 2003
+++ BgChat-Ircd/modules/core/m_nick.c	Mon Mar 29 07:17:53 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_nick.c: Sets a users nick.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_nick.c,v 1.122.2.3 2003/11/07 00:00:42 leeh Exp $
+ *  $Id: m_nick.c,v 1.122.2.3 2004/02/01 00:00:42 MaskBg Exp $
  */
 
 #include "stdinc.h"
@@ -702,6 +701,17 @@
 
 	/* remove all accepts pointing to the client */
 	del_all_accepts(source_p);
+
+
+	if (IsNSId(source_p)) {
+    	    ClearNSId(source_p);
+    	    CurrentIdentUsers--;
+
+            if (CurrentIdentUsers < 0)
+                CurrentIdentUsers= 0;
+
+	}
+
 
 	return 0;
 }
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_part.c BgChat-Ircd/modules/core/m_part.c
--- ircd-ratbox-1.3-1/modules/core/m_part.c	Thu Nov  6 19:00:42 2003
+++ BgChat-Ircd/modules/core/m_part.c	Mon Mar 29 07:17:53 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_part.c: Parts a user from a channel.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_part.c,v 1.80.2.3 2003/11/07 00:00:42 leeh Exp $
+ *  $Id: m_part.c,v 1.80.2.3 2004/01/02 11:23:32 MaskBg Exp $
  */
 
 #include "stdinc.h"
@@ -165,5 +164,9 @@
 				     source_p->name,
 				     source_p->username, source_p->host, chptr->chname);
 	}
+
+	del_nokick_chan(source_p,name);
+
+
 	remove_user_from_channel(msptr);
 }
diff -uNrd ircd-ratbox-1.3-1/modules/m_join.c BgChat-Ircd/modules/m_join.c
--- ircd-ratbox-1.3-1/modules/m_join.c	Mon Nov  3 12:53:43 2003
+++ BgChat-Ircd/modules/m_join.c	Mon Mar 29 07:17:53 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_join.c: Joins a channel.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -224,6 +223,14 @@
 
 		if(!IsOper(source_p) && !IsExemptSpambot(source_p))
 			check_spambot_warning(source_p, name);
+
+
+	    if ((chptr->mode.mode & MODE_JOINF) /* && ServicesOn */ && (!IsNSId(source_p)/* ||
+		    (source_p->ns_reg + ConfigFileEntry.how_old >= time(NULL))*/) && !IsOperRemote(source_p)) {
+		sendto_one(source_p, form_str(ERR_JOINF), me.name, source_p->name, chptr->chname);
+		return;
+	    }
+
 
 		/* can_join checks for +i key, bans etc */
 		if((i = can_join(source_p, chptr, key)))
